package com.dbxml.db.client.tools.command;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: DropBase.java,v 1.4 2004/02/12 00:17:55 bradford Exp $
 */

import java.io.PrintWriter;

import com.dbxml.db.client.CollectionClient;
import com.dbxml.db.client.tools.CommandLine;
import com.dbxml.util.dbXMLException;

/**
 * DropBase serves as a base class for several removal Commands.
 */

public abstract class DropBase extends SingletonBase {
   protected final String getArgumentName() {
      return getType()+" name";
   }

   protected final void process(CollectionClient col, String argument) throws dbXMLException {
      PrintWriter pw = cl.getWriter();

      if ( cl.isPropertyTrue(CommandLine.CONFIRM) ) {
         try {
            String ans = cl.readLine("Delete " + getType() + " (y/N)? ");
            if ( !ans.equalsIgnoreCase("yes") && !ans.equalsIgnoreCase("y") ) {
               pw.println(getType() + " deletion canceled");
               return;
            }
         }
         catch ( Exception e ) {
            throw new dbXMLException("Error obtaining answer");
         }
      }

      if ( dropObject(col, argument) )
         pw.println(getType() + " '" + argument + "' deleted");
      else
         pw.println(getType() + " '" + argument + "' not deleted");
   }

   protected abstract String getType();

   protected abstract boolean dropObject(CollectionClient col, String name) throws dbXMLException;
}
